searchNodes=[{"ref":"GoogleApi.ServiceControl.V1.Api.Services.html","title":"GoogleApi.ServiceControl.V1.Api.Services","type":"module","doc":"API calls for all endpoints tagged Services."},{"ref":"GoogleApi.ServiceControl.V1.Api.Services.html#servicecontrol_services_allocate_quota/4","title":"GoogleApi.ServiceControl.V1.Api.Services.servicecontrol_services_allocate_quota/4","type":"function","doc":"Attempts to allocate quota for the specified consumer. It should be called before the operation is executed. This method requires the servicemanagement.services.quota permission on the specified service. For more information, see Cloud IAM. NOTE: The client must fail-open on server errors INTERNAL, UNKNOWN, DEADLINE_EXCEEDED, and UNAVAILABLE. To ensure system reliability, the server may inject these errors to prohibit any hard dependency on the quota functionality. Parameters connection (GoogleApi.ServiceControl.V1.Connection): Connection to server service_name (String.t): Name of the service as specified in the service configuration. For example, &quot;pubsub.googleapis.com&quot;. See google.api.Service for the definition of a service name. optional_params (keyword()): [optional] Optional parameters :$.xgafv (String.t): V1 error format. :access_token (String.t): OAuth access token. :alt (String.t): Data format for response. :callback (String.t): JSONP :fields (String.t): Selector specifying which fields to include in a partial response. :key (String.t): API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. :oauth_token (String.t): OAuth 2.0 token for the current user. :prettyPrint (boolean()): Returns response with indentations and line breaks. :quotaUser (String.t): Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. :uploadType (String.t): Legacy upload protocol for media (e.g. &quot;media&quot;, &quot;multipart&quot;). :upload_protocol (String.t): Upload protocol for media (e.g. &quot;raw&quot;, &quot;multipart&quot;). :body (GoogleApi.ServiceControl.V1.Model.AllocateQuotaRequest.t): Returns {:ok, %GoogleApi.ServiceControl.V1.Model.AllocateQuotaResponse{}} on success {:error, info} on failure"},{"ref":"GoogleApi.ServiceControl.V1.Api.Services.html#servicecontrol_services_check/4","title":"GoogleApi.ServiceControl.V1.Api.Services.servicecontrol_services_check/4","type":"function","doc":"Checks whether an operation on a service should be allowed to proceed based on the configuration of the service and related policies. It must be called before the operation is executed. If feasible, the client should cache the check results and reuse them for 60 seconds. In case of any server errors, the client should rely on the cached results for much longer time to avoid outage. WARNING: There is general 60s delay for the configuration and policy propagation, therefore callers MUST NOT depend on the Check method having the latest policy information. NOTE: the CheckRequest has the size limit of 64KB. This method requires the servicemanagement.services.check permission on the specified service. For more information, see Cloud IAM. Parameters connection (GoogleApi.ServiceControl.V1.Connection): Connection to server service_name (String.t): The service name as specified in its service configuration. For example, &quot;pubsub.googleapis.com&quot;. See google.api.Service for the definition of a service name. optional_params (keyword()): [optional] Optional parameters :$.xgafv (String.t): V1 error format. :access_token (String.t): OAuth access token. :alt (String.t): Data format for response. :callback (String.t): JSONP :fields (String.t): Selector specifying which fields to include in a partial response. :key (String.t): API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. :oauth_token (String.t): OAuth 2.0 token for the current user. :prettyPrint (boolean()): Returns response with indentations and line breaks. :quotaUser (String.t): Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. :uploadType (String.t): Legacy upload protocol for media (e.g. &quot;media&quot;, &quot;multipart&quot;). :upload_protocol (String.t): Upload protocol for media (e.g. &quot;raw&quot;, &quot;multipart&quot;). :body (GoogleApi.ServiceControl.V1.Model.CheckRequest.t): Returns {:ok, %GoogleApi.ServiceControl.V1.Model.CheckResponse{}} on success {:error, info} on failure"},{"ref":"GoogleApi.ServiceControl.V1.Api.Services.html#servicecontrol_services_report/4","title":"GoogleApi.ServiceControl.V1.Api.Services.servicecontrol_services_report/4","type":"function","doc":"Reports operation results to Google Service Control, such as logs and metrics. It should be called after an operation is completed. If feasible, the client should aggregate reporting data for up to 5 seconds to reduce API traffic. Limiting aggregation to 5 seconds is to reduce data loss during client crashes. Clients should carefully choose the aggregation time window to avoid data loss risk more than 0.01% for business and compliance reasons. NOTE: the ReportRequest has the size limit of 1MB. This method requires the servicemanagement.services.report permission on the specified service. For more information, see Google Cloud IAM. Parameters connection (GoogleApi.ServiceControl.V1.Connection): Connection to server service_name (String.t): The service name as specified in its service configuration. For example, &quot;pubsub.googleapis.com&quot;. See google.api.Service for the definition of a service name. optional_params (keyword()): [optional] Optional parameters :$.xgafv (String.t): V1 error format. :access_token (String.t): OAuth access token. :alt (String.t): Data format for response. :callback (String.t): JSONP :fields (String.t): Selector specifying which fields to include in a partial response. :key (String.t): API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. :oauth_token (String.t): OAuth 2.0 token for the current user. :prettyPrint (boolean()): Returns response with indentations and line breaks. :quotaUser (String.t): Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. :uploadType (String.t): Legacy upload protocol for media (e.g. &quot;media&quot;, &quot;multipart&quot;). :upload_protocol (String.t): Upload protocol for media (e.g. &quot;raw&quot;, &quot;multipart&quot;). :body (GoogleApi.ServiceControl.V1.Model.ReportRequest.t): Returns {:ok, %GoogleApi.ServiceControl.V1.Model.ReportResponse{}} on success {:error, info} on failure"},{"ref":"GoogleApi.ServiceControl.V1.Connection.html","title":"GoogleApi.ServiceControl.V1.Connection","type":"module","doc":"Handle Tesla connections for GoogleApi.ServiceControl.V1."},{"ref":"GoogleApi.ServiceControl.V1.Connection.html#delete/3","title":"GoogleApi.ServiceControl.V1.Connection.delete/3","type":"function","doc":"Perform a DELETE request. See request/1 or request/2 for options definition. delete(&quot;/users&quot;) delete(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) delete(client, &quot;/users&quot;) delete(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.ServiceControl.V1.Connection.html#delete!/3","title":"GoogleApi.ServiceControl.V1.Connection.delete!/3","type":"function","doc":"Perform a DELETE request. See request!/1 or request!/2 for options definition. delete!(&quot;/users&quot;) delete!(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) delete!(client, &quot;/users&quot;) delete!(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.ServiceControl.V1.Connection.html#execute/2","title":"GoogleApi.ServiceControl.V1.Connection.execute/2","type":"function","doc":"Execute a request on this connection Returns Tesla.Env"},{"ref":"GoogleApi.ServiceControl.V1.Connection.html#get/3","title":"GoogleApi.ServiceControl.V1.Connection.get/3","type":"function","doc":"Perform a GET request. See request/1 or request/2 for options definition. get(&quot;/users&quot;) get(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) get(client, &quot;/users&quot;) get(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.ServiceControl.V1.Connection.html#get!/3","title":"GoogleApi.ServiceControl.V1.Connection.get!/3","type":"function","doc":"Perform a GET request. See request!/1 or request!/2 for options definition. get!(&quot;/users&quot;) get!(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) get!(client, &quot;/users&quot;) get!(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.ServiceControl.V1.Connection.html#head/3","title":"GoogleApi.ServiceControl.V1.Connection.head/3","type":"function","doc":"Perform a HEAD request. See request/1 or request/2 for options definition. head(&quot;/users&quot;) head(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) head(client, &quot;/users&quot;) head(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.ServiceControl.V1.Connection.html#head!/3","title":"GoogleApi.ServiceControl.V1.Connection.head!/3","type":"function","doc":"Perform a HEAD request. See request!/1 or request!/2 for options definition. head!(&quot;/users&quot;) head!(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) head!(client, &quot;/users&quot;) head!(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.ServiceControl.V1.Connection.html#new/0","title":"GoogleApi.ServiceControl.V1.Connection.new/0","type":"function","doc":"Configure an authless client connection Returns Tesla.Client.t"},{"ref":"GoogleApi.ServiceControl.V1.Connection.html#new/1","title":"GoogleApi.ServiceControl.V1.Connection.new/1","type":"function","doc":"Configure a client connection using a function which yields a Bearer token. Parameters token_fetcher (function arity of 1): Callback which provides an OAuth2 token given a list of scopes Returns Tesla.Env.client"},{"ref":"GoogleApi.ServiceControl.V1.Connection.html#options/3","title":"GoogleApi.ServiceControl.V1.Connection.options/3","type":"function","doc":"Perform a OPTIONS request. See request/1 or request/2 for options definition. options(&quot;/users&quot;) options(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) options(client, &quot;/users&quot;) options(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.ServiceControl.V1.Connection.html#options!/3","title":"GoogleApi.ServiceControl.V1.Connection.options!/3","type":"function","doc":"Perform a OPTIONS request. See request!/1 or request!/2 for options definition. options!(&quot;/users&quot;) options!(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) options!(client, &quot;/users&quot;) options!(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.ServiceControl.V1.Connection.html#patch/4","title":"GoogleApi.ServiceControl.V1.Connection.patch/4","type":"function","doc":"Perform a PATCH request. See request/1 or request/2 for options definition. patch(&quot;/users&quot;, %{name: &quot;Jon&quot;}) patch(&quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;]) patch(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}) patch(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.ServiceControl.V1.Connection.html#patch!/4","title":"GoogleApi.ServiceControl.V1.Connection.patch!/4","type":"function","doc":"Perform a PATCH request. See request!/1 or request!/2 for options definition. patch!(&quot;/users&quot;, %{name: &quot;Jon&quot;}) patch!(&quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;]) patch!(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}) patch!(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.ServiceControl.V1.Connection.html#post/4","title":"GoogleApi.ServiceControl.V1.Connection.post/4","type":"function","doc":"Perform a POST request. See request/1 or request/2 for options definition. post(&quot;/users&quot;, %{name: &quot;Jon&quot;}) post(&quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;]) post(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}) post(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.ServiceControl.V1.Connection.html#post!/4","title":"GoogleApi.ServiceControl.V1.Connection.post!/4","type":"function","doc":"Perform a POST request. See request!/1 or request!/2 for options definition. post!(&quot;/users&quot;, %{name: &quot;Jon&quot;}) post!(&quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;]) post!(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}) post!(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.ServiceControl.V1.Connection.html#put/4","title":"GoogleApi.ServiceControl.V1.Connection.put/4","type":"function","doc":"Perform a PUT request. See request/1 or request/2 for options definition. put(&quot;/users&quot;, %{name: &quot;Jon&quot;}) put(&quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;]) put(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}) put(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.ServiceControl.V1.Connection.html#put!/4","title":"GoogleApi.ServiceControl.V1.Connection.put!/4","type":"function","doc":"Perform a PUT request. See request!/1 or request!/2 for options definition. put!(&quot;/users&quot;, %{name: &quot;Jon&quot;}) put!(&quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;]) put!(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}) put!(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.ServiceControl.V1.Connection.html#request/2","title":"GoogleApi.ServiceControl.V1.Connection.request/2","type":"function","doc":"Perform a request Options: :method - the request method, one of [:head, :get, :delete, :trace, :options, :post, :put, :patch] :url - either full url e.g. &quot;http://example.com/some/path&quot; or just &quot;/some/path&quot; if using Tesla.Middleware.BaseUrl :query - a keyword list of query params, e.g. [page: 1, per_page: 100] :headers - a keyworld list of headers, e.g. [{&quot;content-type&quot;, &quot;text/plain&quot;}] :body - depends on used middleware: by default it can be a binary if using e.g. JSON encoding middleware it can be a nested map if adapter supports it it can be a Stream with any of the above :opts - custom, per-request middleware or adapter options Examples: ExampleApi.request(method: :get, url: &quot;/users/path&quot;) You can also use shortcut methods like: ExampleApi.get(&quot;/users/1&quot;) or ExampleApi.post(client, &quot;/users&quot;, %{name: &quot;Jon&quot;})"},{"ref":"GoogleApi.ServiceControl.V1.Connection.html#request!/2","title":"GoogleApi.ServiceControl.V1.Connection.request!/2","type":"function","doc":"Perform request and raise in case of error. This is similar to request/2 behaviour from Tesla 0.x See request/2 for list of available options."},{"ref":"GoogleApi.ServiceControl.V1.Connection.html#trace/3","title":"GoogleApi.ServiceControl.V1.Connection.trace/3","type":"function","doc":"Perform a TRACE request. See request/1 or request/2 for options definition. trace(&quot;/users&quot;) trace(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) trace(client, &quot;/users&quot;) trace(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.ServiceControl.V1.Connection.html#trace!/3","title":"GoogleApi.ServiceControl.V1.Connection.trace!/3","type":"function","doc":"Perform a TRACE request. See request!/1 or request!/2 for options definition. trace!(&quot;/users&quot;) trace!(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) trace!(client, &quot;/users&quot;) trace!(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.ServiceControl.V1.Connection.html#t:option/0","title":"GoogleApi.ServiceControl.V1.Connection.option/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.AllocateInfo.html","title":"GoogleApi.ServiceControl.V1.Model.AllocateInfo","type":"module","doc":"Attributes unusedArguments (list(String.t)): A list of label keys that were unused by the server in processing the request. Thus, for similar requests repeated in a certain future time window, the caller can choose to ignore these labels in the requests to achieve better client-side cache hits and quota aggregation. Defaults to nil."},{"ref":"GoogleApi.ServiceControl.V1.Model.AllocateInfo.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.AllocateInfo.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.AllocateInfo.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.AllocateInfo.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.AllocateQuotaRequest.html","title":"GoogleApi.ServiceControl.V1.Model.AllocateQuotaRequest","type":"module","doc":"Request message for the AllocateQuota method. Attributes allocateOperation (GoogleApi.ServiceControl.V1.Model.QuotaOperation.t): Operation that describes the quota allocation. Defaults to nil. serviceConfigId (String.t): Specifies which version of service configuration should be used to process the request. If unspecified or no matching version can be found, the latest one will be used. Defaults to nil."},{"ref":"GoogleApi.ServiceControl.V1.Model.AllocateQuotaRequest.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.AllocateQuotaRequest.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.AllocateQuotaRequest.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.AllocateQuotaRequest.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.AllocateQuotaResponse.html","title":"GoogleApi.ServiceControl.V1.Model.AllocateQuotaResponse","type":"module","doc":"Response message for the AllocateQuota method. Attributes allocateErrors (list(GoogleApi.ServiceControl.V1.Model.QuotaError.t)): Indicates the decision of the allocate. Defaults to nil. allocateInfo (GoogleApi.ServiceControl.V1.Model.AllocateInfo.t): WARNING: DO NOT use this field until this warning message is removed. Defaults to nil. operationId (String.t): The same operation_id value used in the AllocateQuotaRequest. Used for logging and diagnostics purposes. Defaults to nil. quotaMetrics (list(GoogleApi.ServiceControl.V1.Model.MetricValueSet.t)): Quota metrics to indicate the result of allocation. Depending on the request, one or more of the following metrics will be included: Per quota group or per quota metric incremental usage will be specified using the following delta metric : &quot;serviceruntime.googleapis.com/api/consumer/quota_used_count&quot; The quota limit reached condition will be specified using the following boolean metric : &quot;serviceruntime.googleapis.com/quota/exceeded&quot; Defaults to nil. serviceConfigId (String.t): ID of the actual config used to process the request. Defaults to nil."},{"ref":"GoogleApi.ServiceControl.V1.Model.AllocateQuotaResponse.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.AllocateQuotaResponse.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.AllocateQuotaResponse.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.AllocateQuotaResponse.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.AuditLog.html","title":"GoogleApi.ServiceControl.V1.Model.AuditLog","type":"module","doc":"Common audit log format for Google Cloud Platform API operations. Attributes authenticationInfo (GoogleApi.ServiceControl.V1.Model.AuthenticationInfo.t): Authentication information. Defaults to nil. authorizationInfo (list(GoogleApi.ServiceControl.V1.Model.AuthorizationInfo.t)): Authorization information. If there are multiple resources or permissions involved, then there is one AuthorizationInfo element for each {resource, permission} tuple. Defaults to nil. metadata (map()): Other service-specific data about the request, response, and other information associated with the current audited event. Defaults to nil. methodName (String.t): The name of the service method or operation. For API calls, this should be the name of the API method. For example, &quot;google.datastore.v1.Datastore.RunQuery&quot; &quot;google.logging.v1.LoggingService.DeleteLog&quot; Defaults to nil. numResponseItems (String.t): The number of items returned from a List or Query API method, if applicable. Defaults to nil. request (map()): The operation request. This may not include all request parameters, such as those that are too large, privacy-sensitive, or duplicated elsewhere in the log record. It should never include user-generated data, such as file contents. When the JSON object represented here has a proto equivalent, the proto name will be indicated in the @type property. Defaults to nil. requestMetadata (GoogleApi.ServiceControl.V1.Model.RequestMetadata.t): Metadata about the operation. Defaults to nil. resourceLocation (GoogleApi.ServiceControl.V1.Model.ResourceLocation.t): The resource location information. Defaults to nil. resourceName (String.t): The resource or collection that is the target of the operation. The name is a scheme-less URI, not including the API service name. For example: &quot;shelves/SHELF_ID/books&quot; &quot;shelves/SHELF_ID/books/BOOK_ID&quot; Defaults to nil. resourceOriginalState (map()): The resource&#39;s original state before mutation. Present only for operations which have successfully modified the targeted resource(s). In general, this field should contain all changed fields, except those that are already been included in request, response, metadata or service_data fields. When the JSON object represented here has a proto equivalent, the proto name will be indicated in the @type property. Defaults to nil. response (map()): The operation response. This may not include all response elements, such as those that are too large, privacy-sensitive, or duplicated elsewhere in the log record. It should never include user-generated data, such as file contents. When the JSON object represented here has a proto equivalent, the proto name will be indicated in the @type property. Defaults to nil. serviceData (map()): Deprecated, use metadata field instead. Other service-specific data about the request, response, and other activities. Defaults to nil. serviceName (String.t): The name of the API service performing the operation. For example, &quot;datastore.googleapis.com&quot;. Defaults to nil. status (GoogleApi.ServiceControl.V1.Model.Status.t): The status of the overall operation. Defaults to nil."},{"ref":"GoogleApi.ServiceControl.V1.Model.AuditLog.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.AuditLog.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.AuditLog.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.AuditLog.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.Auth.html","title":"GoogleApi.ServiceControl.V1.Model.Auth","type":"module","doc":"This message defines request authentication attributes. Terminology is based on the JSON Web Token (JWT) standard, but the terms also correlate to concepts in other standards. Attributes accessLevels (list(String.t)): A list of access level resource names that allow resources to be accessed by authenticated requester. It is part of Secure GCP processing for the incoming request. An access level string has the format: &quot;//{api_service_name}/accessPolicies/{policy_id}/accessLevels/{short_name}&quot; Example: &quot;//accesscontextmanager.googleapis.com/accessPolicies/MY_POLICY_ID/accessLevels/MY_LEVEL&quot; Defaults to nil. audiences (list(String.t)): The intended audience(s) for this authentication information. Reflects the audience (aud) claim within a JWT. The audience value(s) depends on the issuer, but typically include one or more of the following pieces of information: The services intended to receive the credential such as [&quot;pubsub.googleapis.com&quot;, &quot;storage.googleapis.com&quot;] A set of service-based scopes. For example, [&quot;https://www.googleapis.com/auth/cloud-platform&quot;] The client id of an app, such as the Firebase project id for JWTs from Firebase Auth. Consult the documentation for the credential issuer to determine the information provided. Defaults to nil. claims (map()): Structured claims presented with the credential. JWTs include {key: value} pairs for standard and private claims. The following is a subset of the standard required and optional claims that would typically be presented for a Google-based JWT: {&#39;iss&#39;: &#39;accounts.google.com&#39;, &#39;sub&#39;: &#39;113289723416554971153&#39;, &#39;aud&#39;: [&#39;123456789012&#39;, &#39;pubsub.googleapis.com&#39;], &#39;azp&#39;: &#39;123456789012.apps.googleusercontent.com&#39;, &#39;email&#39;: &#39;jsmith@example.com&#39;, &#39;iat&#39;: 1353601026, &#39;exp&#39;: 1353604926} SAML assertions are similarly specified, but with an identity provider dependent structure. Defaults to nil. presenter (String.t): The authorized presenter of the credential. Reflects the optional Authorized Presenter (azp) claim within a JWT or the OAuth client id. For example, a Google Cloud Platform client id looks as follows: &quot;123456789012.apps.googleusercontent.com&quot;. Defaults to nil. principal (String.t): The authenticated principal. Reflects the issuer (iss) and subject (sub) claims within a JWT. The issuer and subject should be / delimited, with / percent-encoded within the subject fragment. For Google accounts, the principal format is: &quot;https://accounts.google.com/{id}&quot; Defaults to nil."},{"ref":"GoogleApi.ServiceControl.V1.Model.Auth.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.Auth.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.Auth.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.Auth.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.AuthenticationInfo.html","title":"GoogleApi.ServiceControl.V1.Model.AuthenticationInfo","type":"module","doc":"Authentication information for the operation. Attributes authoritySelector (String.t): The authority selector specified by the requestor, if any. It is not guaranteed that the principal was allowed to use this authority. Defaults to nil. principalEmail (String.t): The email address of the authenticated user (or service account on behalf of third party principal) making the request. For privacy reasons, the principal email address is redacted for all read-only operations that fail with a &quot;permission denied&quot; error. Defaults to nil. serviceAccountDelegationInfo (list(GoogleApi.ServiceControl.V1.Model.ServiceAccountDelegationInfo.t)): Identity delegation history of an authenticated service account that makes the request. It contains information on the real authorities that try to access GCP resources by delegating on a service account. When multiple authorities present, they are guaranteed to be sorted based on the original ordering of the identity delegation events. Defaults to nil. serviceAccountKeyName (String.t): The name of the service account key used to create or exchange credentials for authenticating the service account making the request. This is a scheme-less URI full resource name. For example: &quot;//iam.googleapis.com/projects/{PROJECT_ID}/serviceAccounts/{ACCOUNT}/keys/{key}&quot; Defaults to nil. thirdPartyPrincipal (map()): The third party identification (if any) of the authenticated user making the request. When the JSON object represented here has a proto equivalent, the proto name will be indicated in the @type property. Defaults to nil."},{"ref":"GoogleApi.ServiceControl.V1.Model.AuthenticationInfo.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.AuthenticationInfo.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.AuthenticationInfo.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.AuthenticationInfo.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.AuthorizationInfo.html","title":"GoogleApi.ServiceControl.V1.Model.AuthorizationInfo","type":"module","doc":"Authorization information for the operation. Attributes granted (boolean()): Whether or not authorization for resource and permission was granted. Defaults to nil. permission (String.t): The required IAM permission. Defaults to nil. resource (String.t): The resource being accessed, as a REST-style string. For example: bigquery.googleapis.com/projects/PROJECTID/datasets/DATASETID Defaults to nil. resourceAttributes (GoogleApi.ServiceControl.V1.Model.Resource.t): Resource attributes used in IAM condition evaluation. This field contains resource attributes like resource type and resource name. To get the whole view of the attributes used in IAM condition evaluation, the user must also look into AuditLog.request_metadata.request_attributes. Defaults to nil."},{"ref":"GoogleApi.ServiceControl.V1.Model.AuthorizationInfo.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.AuthorizationInfo.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.AuthorizationInfo.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.AuthorizationInfo.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.CheckError.html","title":"GoogleApi.ServiceControl.V1.Model.CheckError","type":"module","doc":"Defines the errors to be returned in google.api.servicecontrol.v1.CheckResponse.check_errors. Attributes code (String.t): The error code. Defaults to nil. detail (String.t): Free-form text providing details on the error cause of the error. Defaults to nil. status (GoogleApi.ServiceControl.V1.Model.Status.t): Contains public information about the check error. If available, status.code will be non zero and client can propagate it out as public error. Defaults to nil. subject (String.t): Subject to whom this error applies. See the specific code enum for more details on this field. For example: “project:” “folder:” “organization:” Defaults to nil."},{"ref":"GoogleApi.ServiceControl.V1.Model.CheckError.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.CheckError.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.CheckError.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.CheckError.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.CheckInfo.html","title":"GoogleApi.ServiceControl.V1.Model.CheckInfo","type":"module","doc":"Contains additional information about the check operation. Attributes consumerInfo (GoogleApi.ServiceControl.V1.Model.ConsumerInfo.t): Consumer info of this check. Defaults to nil. unusedArguments (list(String.t)): A list of fields and label keys that are ignored by the server. The client doesn&#39;t need to send them for following requests to improve performance and allow better aggregation. Defaults to nil."},{"ref":"GoogleApi.ServiceControl.V1.Model.CheckInfo.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.CheckInfo.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.CheckInfo.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.CheckInfo.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.CheckRequest.html","title":"GoogleApi.ServiceControl.V1.Model.CheckRequest","type":"module","doc":"Request message for the Check method. Attributes operation (GoogleApi.ServiceControl.V1.Model.Operation.t): The operation to be checked. Defaults to nil. requestProjectSettings (boolean()): Requests the project settings to be returned as part of the check response. Defaults to nil. serviceConfigId (String.t): Specifies which version of service configuration should be used to process the request. If unspecified or no matching version can be found, the latest one will be used. Defaults to nil. skipActivationCheck (boolean()): Indicates if service activation check should be skipped for this request. Default behavior is to perform the check and apply relevant quota. WARNING: Setting this flag to &quot;true&quot; will disable quota enforcement. Defaults to nil."},{"ref":"GoogleApi.ServiceControl.V1.Model.CheckRequest.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.CheckRequest.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.CheckRequest.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.CheckRequest.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.CheckResponse.html","title":"GoogleApi.ServiceControl.V1.Model.CheckResponse","type":"module","doc":"Response message for the Check method. Attributes checkErrors (list(GoogleApi.ServiceControl.V1.Model.CheckError.t)): Indicate the decision of the check. If no check errors are present, the service should process the operation. Otherwise the service should use the list of errors to determine the appropriate action. Defaults to nil. checkInfo (GoogleApi.ServiceControl.V1.Model.CheckInfo.t): Feedback data returned from the server during processing a Check request. Defaults to nil. operationId (String.t): The same operation_id value used in the CheckRequest. Used for logging and diagnostics purposes. Defaults to nil. quotaInfo (GoogleApi.ServiceControl.V1.Model.QuotaInfo.t): Quota information for the check request associated with this response. Defaults to nil. serviceConfigId (String.t): The actual config id used to process the request. Defaults to nil. serviceRolloutId (String.t): Unimplemented. The current service rollout id used to process the request. Defaults to nil."},{"ref":"GoogleApi.ServiceControl.V1.Model.CheckResponse.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.CheckResponse.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.CheckResponse.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.CheckResponse.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.ConsumerInfo.html","title":"GoogleApi.ServiceControl.V1.Model.ConsumerInfo","type":"module","doc":"ConsumerInfo provides information about the consumer. Attributes consumerNumber (String.t): The consumer identity number, can be Google cloud project number, folder number or organization number e.g. 1234567890. A value of 0 indicates no consumer number is found. Defaults to nil. projectNumber (String.t): The Google cloud project number, e.g. 1234567890. A value of 0 indicates no project number is found. NOTE: This field is deprecated after Chemist support flexible consumer id. New code should not depend on this field anymore. Defaults to nil. type (String.t): The type of the consumer which should have been defined in Google Resource Manager. Defaults to nil."},{"ref":"GoogleApi.ServiceControl.V1.Model.ConsumerInfo.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.ConsumerInfo.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.ConsumerInfo.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.ConsumerInfo.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.Distribution.html","title":"GoogleApi.ServiceControl.V1.Model.Distribution","type":"module","doc":"Distribution represents a frequency distribution of double-valued sample points. It contains the size of the population of sample points plus additional optional information: the arithmetic mean of the samples the minimum and maximum of the samples the sum-squared-deviation of the samples, used to compute variance a histogram of the values of the sample points Attributes bucketCounts (list(String.t)): The number of samples in each histogram bucket. bucket_counts are optional. If present, they must sum to the count value. The buckets are defined below in bucket_option. There are N buckets. bucket_counts[0] is the number of samples in the underflow bucket. bucket_counts[1] to bucket_counts[N-1] are the numbers of samples in each of the finite buckets. And bucket_counts[N] is the number of samples in the overflow bucket. See the comments ofbucket_optionbelow for more details. Any suffix of trailing zeros may be omitted. Defaults tonil. - count (String.t): The total number of samples in the distribution. Must be &gt;= 0. Defaults tonil. - explicitBuckets (GoogleApi.ServiceControl.V1.Model.ExplicitBuckets.t): Buckets with arbitrary user-provided width. Defaults tonil. - exponentialBuckets (GoogleApi.ServiceControl.V1.Model.ExponentialBuckets.t): Buckets with exponentially growing width. Defaults tonil. - linearBuckets (GoogleApi.ServiceControl.V1.Model.LinearBuckets.t): Buckets with constant width. Defaults tonil. - maximum (float()): The maximum of the population of values. Ignored ifcountis zero. Defaults tonil. - mean (float()): The arithmetic mean of the samples in the distribution. Ifcountis zero then this field must be zero. Defaults tonil. - minimum (float()): The minimum of the population of values. Ignored ifcountis zero. Defaults tonil. - sumOfSquaredDeviation (float()): The sum of squared deviations from the mean: Sum[i=1..count]((x_i - mean)^2) where each x_i is a sample values. Ifcountis zero then this field must be zero, otherwise validation of the request fails. Defaults tonil`."},{"ref":"GoogleApi.ServiceControl.V1.Model.Distribution.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.Distribution.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.Distribution.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.Distribution.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.ExplicitBuckets.html","title":"GoogleApi.ServiceControl.V1.Model.ExplicitBuckets","type":"module","doc":"Describing buckets with arbitrary user-provided width. Attributes bounds (list(float())): &#39;bound&#39; is a list of strictly increasing boundaries between buckets. Note that a list of length N-1 defines N buckets because of fenceposting. See comments on bucket_options for details. The i&#39;th finite bucket covers the interval [bound[i-1], bound[i]) where i ranges from 1 to bound_size() - 1. Note that there are no finite buckets at all if &#39;bound&#39; only contains a single element; in that special case the single bound defines the boundary between the underflow and overflow buckets. bucket number lower bound upper bound i == 0 (underflow) -inf bound[i] 0 &lt; i &lt; bound_size() bound[i-1] bound[i] i == bound_size() (overflow) bound[i-1] +inf Defaults to nil."},{"ref":"GoogleApi.ServiceControl.V1.Model.ExplicitBuckets.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.ExplicitBuckets.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.ExplicitBuckets.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.ExplicitBuckets.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.ExponentialBuckets.html","title":"GoogleApi.ServiceControl.V1.Model.ExponentialBuckets","type":"module","doc":"Describing buckets with exponentially growing width. Attributes growthFactor (float()): The i&#39;th exponential bucket covers the interval [scale growth_factor^(i-1), scale growth_factor^i) where i ranges from 1 to num_finite_buckets inclusive. Must be larger than 1.0. Defaults to nil. numFiniteBuckets (integer()): The number of finite buckets. With the underflow and overflow buckets, the total number of buckets is num_finite_buckets + 2. See comments on bucket_options for details. Defaults to nil. scale (float()): The i&#39;th exponential bucket covers the interval [scale growth_factor^(i-1), scale growth_factor^i) where i ranges from 1 to num_finite_buckets inclusive. Must be &gt; 0. Defaults to nil."},{"ref":"GoogleApi.ServiceControl.V1.Model.ExponentialBuckets.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.ExponentialBuckets.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.ExponentialBuckets.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.ExponentialBuckets.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.FirstPartyPrincipal.html","title":"GoogleApi.ServiceControl.V1.Model.FirstPartyPrincipal","type":"module","doc":"First party identity principal. Attributes principalEmail (String.t): The email address of a Google account. . Defaults to nil. serviceMetadata (map()): Metadata about the service that uses the service account. . Defaults to nil."},{"ref":"GoogleApi.ServiceControl.V1.Model.FirstPartyPrincipal.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.FirstPartyPrincipal.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.FirstPartyPrincipal.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.FirstPartyPrincipal.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.HttpRequest.html","title":"GoogleApi.ServiceControl.V1.Model.HttpRequest","type":"module","doc":"A common proto for logging HTTP requests. Only contains semantics defined by the HTTP specification. Product-specific logging information MUST be defined in a separate message. Attributes cacheFillBytes (String.t): The number of HTTP response bytes inserted into cache. Set only when a cache fill was attempted. Defaults to nil. cacheHit (boolean()): Whether or not an entity was served from cache (with or without validation). Defaults to nil. cacheLookup (boolean()): Whether or not a cache lookup was attempted. Defaults to nil. cacheValidatedWithOriginServer (boolean()): Whether or not the response was validated with the origin server before being served from cache. This field is only meaningful if cache_hit is True. Defaults to nil. latency (String.t): The request processing latency on the server, from the time the request was received until the response was sent. Defaults to nil. protocol (String.t): Protocol used for the request. Examples: &quot;HTTP/1.1&quot;, &quot;HTTP/2&quot;, &quot;websocket&quot; Defaults to nil. referer (String.t): The referer URL of the request, as defined in HTTP/1.1 Header Field Definitions. Defaults to nil. remoteIp (String.t): The IP address (IPv4 or IPv6) of the client that issued the HTTP request. Examples: &quot;192.168.1.1&quot;, &quot;FE80::0202:B3FF:FE1E:8329&quot;. Defaults to nil. requestMethod (String.t): The request method. Examples: &quot;GET&quot;, &quot;HEAD&quot;, &quot;PUT&quot;, &quot;POST&quot;. Defaults to nil. requestSize (String.t): The size of the HTTP request message in bytes, including the request headers and the request body. Defaults to nil. requestUrl (String.t): The scheme (http, https), the host name, the path, and the query portion of the URL that was requested. Example: &quot;http://example.com/some/info?color=red&quot;. Defaults to nil. responseSize (String.t): The size of the HTTP response message sent back to the client, in bytes, including the response headers and the response body. Defaults to nil. serverIp (String.t): The IP address (IPv4 or IPv6) of the origin server that the request was sent to. Defaults to nil. status (integer()): The response code indicating the status of the response. Examples: 200, 404. Defaults to nil. userAgent (String.t): The user agent sent by the client. Example: &quot;Mozilla/4.0 (compatible; MSIE 6.0; Windows 98; Q312461; .NET CLR 1.0.3705)&quot;. Defaults to nil."},{"ref":"GoogleApi.ServiceControl.V1.Model.HttpRequest.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.HttpRequest.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.HttpRequest.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.HttpRequest.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.LinearBuckets.html","title":"GoogleApi.ServiceControl.V1.Model.LinearBuckets","type":"module","doc":"Describing buckets with constant width. Attributes numFiniteBuckets (integer()): The number of finite buckets. With the underflow and overflow buckets, the total number of buckets is num_finite_buckets + 2. See comments on bucket_options for details. Defaults to nil. offset (float()): The i&#39;th linear bucket covers the interval [offset + (i-1) width, offset + i width) where i ranges from 1 to num_finite_buckets, inclusive. Defaults to nil. width (float()): The i&#39;th linear bucket covers the interval [offset + (i-1) width, offset + i width) where i ranges from 1 to num_finite_buckets, inclusive. Must be strictly positive. Defaults to nil."},{"ref":"GoogleApi.ServiceControl.V1.Model.LinearBuckets.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.LinearBuckets.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.LinearBuckets.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.LinearBuckets.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.LogEntry.html","title":"GoogleApi.ServiceControl.V1.Model.LogEntry","type":"module","doc":"An individual log entry. Attributes httpRequest (GoogleApi.ServiceControl.V1.Model.HttpRequest.t): Optional. Information about the HTTP request associated with this log entry, if applicable. Defaults to nil. insertId (String.t): A unique ID for the log entry used for deduplication. If omitted, the implementation will generate one based on operation_id. Defaults to nil. labels (map()): A set of user-defined (key, value) data that provides additional information about the log entry. Defaults to nil. name (String.t): Required. The log to which this log entry belongs. Examples: &quot;syslog&quot;, &quot;book_log&quot;. Defaults to nil. operation (GoogleApi.ServiceControl.V1.Model.LogEntryOperation.t): Optional. Information about an operation associated with the log entry, if applicable. Defaults to nil. protoPayload (map()): The log entry payload, represented as a protocol buffer that is expressed as a JSON object. The only accepted type currently is AuditLog. Defaults to nil. severity (String.t): The severity of the log entry. The default value is LogSeverity.DEFAULT. Defaults to nil. structPayload (map()): The log entry payload, represented as a structure that is expressed as a JSON object. Defaults to nil. textPayload (String.t): The log entry payload, represented as a Unicode string (UTF-8). Defaults to nil. timestamp (DateTime.t): The time the event described by the log entry occurred. If omitted, defaults to operation start time. Defaults to nil. trace (String.t): Optional. Resource name of the trace associated with the log entry, if any. If this field contains a relative resource name, you can assume the name is relative to //tracing.googleapis.com. Example: projects/my-projectid/traces/06796866738c859f2f19b7cfb3214824 Defaults to nil."},{"ref":"GoogleApi.ServiceControl.V1.Model.LogEntry.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.LogEntry.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.LogEntry.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.LogEntry.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.LogEntryOperation.html","title":"GoogleApi.ServiceControl.V1.Model.LogEntryOperation","type":"module","doc":"Additional information about a potentially long-running operation with which a log entry is associated. Attributes first (boolean()): Optional. Set this to True if this is the first log entry in the operation. Defaults to nil. id (String.t): Optional. An arbitrary operation identifier. Log entries with the same identifier are assumed to be part of the same operation. Defaults to nil. last (boolean()): Optional. Set this to True if this is the last log entry in the operation. Defaults to nil. producer (String.t): Optional. An arbitrary producer identifier. The combination of id and producer must be globally unique. Examples for producer: &quot;MyDivision.MyBigCompany.com&quot;, &quot;github.com/MyProject/MyApplication&quot;. Defaults to nil."},{"ref":"GoogleApi.ServiceControl.V1.Model.LogEntryOperation.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.LogEntryOperation.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.LogEntryOperation.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.LogEntryOperation.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.MetricValue.html","title":"GoogleApi.ServiceControl.V1.Model.MetricValue","type":"module","doc":"Represents a single metric value. Attributes boolValue (boolean()): A boolean value. Defaults to nil. distributionValue (GoogleApi.ServiceControl.V1.Model.Distribution.t): A distribution value. Defaults to nil. doubleValue (float()): A double precision floating point value. Defaults to nil. endTime (DateTime.t): The end of the time period over which this metric value&#39;s measurement applies. Defaults to nil. int64Value (String.t): A signed 64-bit integer value. Defaults to nil. labels (map()): The labels describing the metric value. See comments on google.api.servicecontrol.v1.Operation.labels for the overriding relationship. Defaults to nil. moneyValue (GoogleApi.ServiceControl.V1.Model.Money.t): A money value. Defaults to nil. startTime (DateTime.t): The start of the time period over which this metric value&#39;s measurement applies. The time period has different semantics for different metric types (cumulative, delta, and gauge). See the metric definition documentation in the service configuration for details. Defaults to nil. stringValue (String.t): A text string value. Defaults to nil."},{"ref":"GoogleApi.ServiceControl.V1.Model.MetricValue.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.MetricValue.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.MetricValue.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.MetricValue.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.MetricValueSet.html","title":"GoogleApi.ServiceControl.V1.Model.MetricValueSet","type":"module","doc":"Represents a set of metric values in the same metric. Each metric value in the set should have a unique combination of start time, end time, and label values. Attributes metricName (String.t): The metric name defined in the service configuration. Defaults to nil. metricValues (list(GoogleApi.ServiceControl.V1.Model.MetricValue.t)): The values in this metric. Defaults to nil."},{"ref":"GoogleApi.ServiceControl.V1.Model.MetricValueSet.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.MetricValueSet.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.MetricValueSet.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.MetricValueSet.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.Money.html","title":"GoogleApi.ServiceControl.V1.Model.Money","type":"module","doc":"Represents an amount of money with its currency type. Attributes currencyCode (String.t): The 3-letter currency code defined in ISO 4217. Defaults to nil. nanos (integer()): Number of nano (10^-9) units of the amount. The value must be between -999,999,999 and +999,999,999 inclusive. If units is positive, nanos must be positive or zero. If units is zero, nanos can be positive, zero, or negative. If units is negative, nanos must be negative or zero. For example $-1.75 is represented as units=-1 and nanos=-750,000,000. Defaults to nil. units (String.t): The whole units of the amount. For example if currencyCode is &quot;USD&quot;, then 1 unit is one US dollar. Defaults to nil."},{"ref":"GoogleApi.ServiceControl.V1.Model.Money.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.Money.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.Money.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.Money.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.Operation.html","title":"GoogleApi.ServiceControl.V1.Model.Operation","type":"module","doc":"Represents information regarding an operation. Attributes consumerId (String.t): Identity of the consumer who is using the service. This field should be filled in for the operations initiated by a consumer, but not for service-initiated operations that are not related to a specific consumer. This can be in one of the following formats: project:PROJECT_ID, project_number:PROJECT_NUMBER, projects/PROJECT_ID or PROJECT_NUMBER, folders/FOLDER_NUMBER, organizations/ORGANIZATION_NUMBER, api_key:API_KEY. Defaults to nil. endTime (DateTime.t): End time of the operation. Required when the operation is used in ServiceController.Report, but optional when the operation is used in ServiceController.Check. Defaults to nil. importance (String.t): DO NOT USE. This is an experimental field. Defaults to nil. labels (map()): Labels describing the operation. Only the following labels are allowed: Labels describing monitored resources as defined in the service configuration. Default labels of metric values. When specified, labels defined in the metric value override these default. The following labels defined by Google Cloud Platform: cloud.googleapis.com/location describing the location where the operation happened, servicecontrol.googleapis.com/user_agent describing the user agent of the API request, servicecontrol.googleapis.com/service_agent describing the service used to handle the API request (e.g. ESP), servicecontrol.googleapis.com/platform describing the platform where the API is served, such as App Engine, Compute Engine, or Kubernetes Engine. Defaults to nil. logEntries (list(GoogleApi.ServiceControl.V1.Model.LogEntry.t)): Represents information to be logged. Defaults to nil. metricValueSets (list(GoogleApi.ServiceControl.V1.Model.MetricValueSet.t)): Represents information about this operation. Each MetricValueSet corresponds to a metric defined in the service configuration. The data type used in the MetricValueSet must agree with the data type specified in the metric definition. Within a single operation, it is not allowed to have more than one MetricValue instances that have the same metric names and identical label value combinations. If a request has such duplicated MetricValue instances, the entire request is rejected with an invalid argument error. Defaults to nil. operationId (String.t): Identity of the operation. This must be unique within the scope of the service that generated the operation. If the service calls Check() and Report() on the same operation, the two calls should carry the same id. UUID version 4 is recommended, though not required. In scenarios where an operation is computed from existing information and an idempotent id is desirable for deduplication purpose, UUID version 5 is recommended. See RFC 4122 for details. Defaults to nil. operationName (String.t): Fully qualified name of the operation. Reserved for future use. Defaults to nil. quotaProperties (GoogleApi.ServiceControl.V1.Model.QuotaProperties.t): Represents the properties needed for quota check. Applicable only if this operation is for a quota check request. If this is not specified, no quota check will be performed. Defaults to nil. resourceContainer (String.t): DO NOT USE. This field is deprecated, use &quot;resources&quot; field instead. The resource name of the parent of a resource in the resource hierarchy. This can be in one of the following formats: “projects/” “folders/” “organizations/” Defaults to nil. resources (list(GoogleApi.ServiceControl.V1.Model.ResourceInfo.t)): The resources that are involved in the operation. The maximum supported number of entries in this field is 100. Defaults to nil. startTime (DateTime.t): Required. Start time of the operation. Defaults to nil. userLabels (map()): User defined labels for the resource that this operation is associated with. Only a combination of 1000 user labels per consumer project are allowed. Defaults to nil."},{"ref":"GoogleApi.ServiceControl.V1.Model.Operation.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.Operation.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.Operation.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.Operation.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.Peer.html","title":"GoogleApi.ServiceControl.V1.Model.Peer","type":"module","doc":"This message defines attributes for a node that handles a network request. The node can be either a service or an application that sends, forwards, or receives the request. Service peers should fill in the service, principal, and labels as appropriate. Attributes ip (String.t): The IP address of the peer. Defaults to nil. labels (map()): The labels associated with the peer. Defaults to nil. port (String.t): The network port of the peer. Defaults to nil. principal (String.t): The identity of this peer. Similar to Request.auth.principal, but relative to the peer instead of the request. For example, the idenity associated with a load balancer that forwared the request. Defaults to nil. regionCode (String.t): The CLDR country/region code associated with the above IP address. If the IP address is private, the region_code should reflect the physical location where this peer is running. Defaults to nil. service (String.t): The canonical service name of the peer. NOTE: different systems may have different service naming schemes. Defaults to nil."},{"ref":"GoogleApi.ServiceControl.V1.Model.Peer.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.Peer.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.Peer.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.Peer.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.QuotaError.html","title":"GoogleApi.ServiceControl.V1.Model.QuotaError","type":"module","doc":"Represents error information for QuotaOperation. Attributes code (String.t): Error code. Defaults to nil. description (String.t): Free-form text that provides details on the cause of the error. Defaults to nil. subject (String.t): Subject to whom this error applies. See the specific enum for more details on this field. For example, &quot;clientip:&quot; or &quot;project:&quot;. Defaults to nil."},{"ref":"GoogleApi.ServiceControl.V1.Model.QuotaError.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.QuotaError.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.QuotaError.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.QuotaError.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.QuotaInfo.html","title":"GoogleApi.ServiceControl.V1.Model.QuotaInfo","type":"module","doc":"Contains the quota information for a quota check response. Attributes limitExceeded (list(String.t)): Quota Metrics that have exceeded quota limits. For QuotaGroup-based quota, this is QuotaGroup.name For QuotaLimit-based quota, this is QuotaLimit.name See: google.api.Quota Deprecated: Use quota_metrics to get per quota group limit exceeded status. Defaults to nil. quotaConsumed (map()): Map of quota group name to the actual number of tokens consumed. If the quota check was not successful, then this will not be populated due to no quota consumption. We are not merging this field with &#39;quota_metrics&#39; field because of the complexity of scaling in Chemist client code base. For simplicity, we will keep this field for Castor (that scales quota usage) and &#39;quota_metrics&#39; for SuperQuota (that doesn&#39;t scale quota usage). Defaults to nil. quotaMetrics (list(GoogleApi.ServiceControl.V1.Model.MetricValueSet.t)): Quota metrics to indicate the usage. Depending on the check request, one or more of the following metrics will be included: For rate quota, per quota group or per quota metric incremental usage will be specified using the following delta metric: &quot;serviceruntime.googleapis.com/api/consumer/quota_used_count&quot; For allocation quota, per quota metric total usage will be specified using the following gauge metric: &quot;serviceruntime.googleapis.com/allocation/consumer/quota_used_count&quot; For both rate quota and allocation quota, the quota limit reached condition will be specified using the following boolean metric: &quot;serviceruntime.googleapis.com/quota/exceeded&quot; Defaults to nil."},{"ref":"GoogleApi.ServiceControl.V1.Model.QuotaInfo.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.QuotaInfo.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.QuotaInfo.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.QuotaInfo.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.QuotaOperation.html","title":"GoogleApi.ServiceControl.V1.Model.QuotaOperation","type":"module","doc":"Represents information regarding a quota operation. Attributes consumerId (String.t): Identity of the consumer for whom this quota operation is being performed. This can be in one of the following formats: project:, project_number:, api_key:. Defaults to nil. labels (map()): Labels describing the operation. Defaults to nil. methodName (String.t): Fully qualified name of the API method for which this quota operation is requested. This name is used for matching quota rules or metric rules and billing status rules defined in service configuration. This field should not be set if any of the following is true: (1) the quota operation is performed on non-API resources. (2) quota_metrics is set because the caller is doing quota override. Example of an RPC method name: google.example.library.v1.LibraryService.CreateShelf Defaults to nil. operationId (String.t): Identity of the operation. This is expected to be unique within the scope of the service that generated the operation, and guarantees idempotency in case of retries. UUID version 4 is recommended, though not required. In scenarios where an operation is computed from existing information and an idempotent id is desirable for deduplication purpose, UUID version 5 is recommended. See RFC 4122 for details. Defaults to nil. quotaMetrics (list(GoogleApi.ServiceControl.V1.Model.MetricValueSet.t)): Represents information about this operation. Each MetricValueSet corresponds to a metric defined in the service configuration. The data type used in the MetricValueSet must agree with the data type specified in the metric definition. Within a single operation, it is not allowed to have more than one MetricValue instances that have the same metric names and identical label value combinations. If a request has such duplicated MetricValue instances, the entire request is rejected with an invalid argument error. This field is mutually exclusive with method_name. Defaults to nil. quotaMode (String.t): Quota mode for this operation. Defaults to nil."},{"ref":"GoogleApi.ServiceControl.V1.Model.QuotaOperation.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.QuotaOperation.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.QuotaOperation.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.QuotaOperation.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.QuotaProperties.html","title":"GoogleApi.ServiceControl.V1.Model.QuotaProperties","type":"module","doc":"Represents the properties needed for quota operations. Attributes quotaMode (String.t): Quota mode for this operation. Defaults to nil."},{"ref":"GoogleApi.ServiceControl.V1.Model.QuotaProperties.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.QuotaProperties.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.QuotaProperties.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.QuotaProperties.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.ReportError.html","title":"GoogleApi.ServiceControl.V1.Model.ReportError","type":"module","doc":"Represents the processing error of one Operation in the request. Attributes operationId (String.t): The Operation.operation_id value from the request. Defaults to nil. status (GoogleApi.ServiceControl.V1.Model.Status.t): Details of the error when processing the Operation. Defaults to nil."},{"ref":"GoogleApi.ServiceControl.V1.Model.ReportError.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.ReportError.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.ReportError.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.ReportError.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.ReportInfo.html","title":"GoogleApi.ServiceControl.V1.Model.ReportInfo","type":"module","doc":"Contains additional info about the report operation. Attributes operationId (String.t): The Operation.operation_id value from the request. Defaults to nil. quotaInfo (GoogleApi.ServiceControl.V1.Model.QuotaInfo.t): Quota usage info when processing the Operation. Defaults to nil."},{"ref":"GoogleApi.ServiceControl.V1.Model.ReportInfo.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.ReportInfo.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.ReportInfo.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.ReportInfo.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.ReportRequest.html","title":"GoogleApi.ServiceControl.V1.Model.ReportRequest","type":"module","doc":"Request message for the Report method. Attributes operations (list(GoogleApi.ServiceControl.V1.Model.Operation.t)): Operations to be reported. Typically the service should report one operation per request. Putting multiple operations into a single request is allowed, but should be used only when multiple operations are natually available at the time of the report. If multiple operations are in a single request, the total request size should be no larger than 1MB. See ReportResponse.report_errors for partial failure behavior. Defaults to nil. serviceConfigId (String.t): Specifies which version of service config should be used to process the request. If unspecified or no matching version can be found, the latest one will be used. Defaults to nil."},{"ref":"GoogleApi.ServiceControl.V1.Model.ReportRequest.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.ReportRequest.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.ReportRequest.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.ReportRequest.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.ReportResponse.html","title":"GoogleApi.ServiceControl.V1.Model.ReportResponse","type":"module","doc":"Response message for the Report method. Attributes reportErrors (list(GoogleApi.ServiceControl.V1.Model.ReportError.t)): Partial failures, one for each Operation in the request that failed processing. There are three possible combinations of the RPC status: The combination of a successful RPC status and an empty report_errors list indicates a complete success where all Operations in the request are processed successfully. The combination of a successful RPC status and a non-empty report_errors list indicates a partial success where some Operations in the request succeeded. Each Operation that failed processing has a corresponding item in this list. A failed RPC status indicates a general non-deterministic failure. When this happens, it&#39;s impossible to know which of the &#39;Operations&#39; in the request succeeded or failed. Defaults to nil. reportInfos (list(GoogleApi.ServiceControl.V1.Model.ReportInfo.t)): Quota usage for each quota release Operation request. Fully or partially failed quota release request may or may not be present in report_quota_info. For example, a failed quota release request will have the current quota usage info when precise quota library returns the info. A deadline exceeded quota request will not have quota usage info. If there is no quota release request, report_quota_info will be empty. Defaults to nil. serviceConfigId (String.t): The actual config id used to process the request. Defaults to nil. serviceRolloutId (String.t): Unimplemented. The current service rollout id used to process the request. Defaults to nil."},{"ref":"GoogleApi.ServiceControl.V1.Model.ReportResponse.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.ReportResponse.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.ReportResponse.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.ReportResponse.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.Request.html","title":"GoogleApi.ServiceControl.V1.Model.Request","type":"module","doc":"This message defines attributes for an HTTP request. If the actual request is not an HTTP request, the runtime system should try to map the actual request to an equivalent HTTP request. Attributes auth (GoogleApi.ServiceControl.V1.Model.Auth.t): The request authentication. May be absent for unauthenticated requests. Derived from the HTTP request Authorization header or equivalent. Defaults to nil. fragment (String.t): The HTTP URL fragment. No URL decoding is performed. Defaults to nil. headers (map()): The HTTP request headers. If multiple headers share the same key, they must be merged according to the HTTP spec. All header keys must be lowercased, because HTTP header keys are case-insensitive. Defaults to nil. host (String.t): The HTTP request Host header value. Defaults to nil. id (String.t): The unique ID for a request, which can be propagated to downstream systems. The ID should have low probability of collision within a single day for a specific service. Defaults to nil. method (String.t): The HTTP request method, such as GET, POST. Defaults to nil. path (String.t): The HTTP URL path. Defaults to nil. protocol (String.t): The network protocol used with the request, such as &quot;http/1.1&quot;, &quot;spdy/3&quot;, &quot;h2&quot;, &quot;h2c&quot;, &quot;webrtc&quot;, &quot;tcp&quot;, &quot;udp&quot;, &quot;quic&quot;. See https://www.iana.org/assignments/tls-extensiontype-values/tls-extensiontype-values.xhtml#alpn-protocol-ids for details. Defaults to nil. query (String.t): The HTTP URL query in the format of name1=value&amp;name2=value2, as it appears in the first line of the HTTP request. No decoding is performed. Defaults tonil. - reason (String.t): A special parameter for request reason. It is used by security systems to associate auditing information with a request. Defaults tonil. - scheme (String.t): The HTTP URL scheme, such ashttpandhttps. Defaults tonil. - size (String.t): The HTTP request size in bytes. If unknown, it must be -1. Defaults tonil. - time (DateTime.t): The timestamp when thedestinationservice receives the first byte of the request. Defaults tonil`."},{"ref":"GoogleApi.ServiceControl.V1.Model.Request.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.Request.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.Request.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.Request.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.RequestMetadata.html","title":"GoogleApi.ServiceControl.V1.Model.RequestMetadata","type":"module","doc":"Metadata about the request. Attributes callerIp (String.t): The IP address of the caller. For caller from internet, this will be public IPv4 or IPv6 address. For caller from a Compute Engine VM with external IP address, this will be the VM&#39;s external IP address. For caller from a Compute Engine VM without external IP address, if the VM is in the same organization (or project) as the accessed resource, caller_ip will be the VM&#39;s internal IPv4 address, otherwise the caller_ip will be redacted to &quot;gce-internal-ip&quot;. See https://cloud.google.com/compute/docs/vpc/ for more information. Defaults to nil. callerNetwork (String.t): The network of the caller. Set only if the network host project is part of the same GCP organization (or project) as the accessed resource. See https://cloud.google.com/compute/docs/vpc/ for more information. This is a scheme-less URI full resource name. For example: &quot;//compute.googleapis.com/projects/PROJECT_ID/global/networks/NETWORK_ID&quot; Defaults to nil. callerSuppliedUserAgent (String.t): The user agent of the caller. This information is not authenticated and should be treated accordingly. For example: google-api-python-client/1.4.0: The request was made by the Google API client for Python. Cloud SDK Command Line Tool apitools-client/1.0 gcloud/0.9.62: The request was made by the Google Cloud SDK CLI (gcloud). AppEngine-Google; (+http://code.google.com/appengine; appid: s~my-project: The request was made from the my-project App Engine app. NOLINT Defaults to nil. destinationAttributes (GoogleApi.ServiceControl.V1.Model.Peer.t): The destination of a network activity, such as accepting a TCP connection. In a multi hop network activity, the destination represents the receiver of the last hop. Only two fields are used in this message, Peer.port and Peer.ip. These fields are optionally populated by those services utilizing the IAM condition feature. Defaults to nil. requestAttributes (GoogleApi.ServiceControl.V1.Model.Request.t): Request attributes used in IAM condition evaluation. This field contains request attributes like request time and access levels associated with the request. To get the whole view of the attributes used in IAM condition evaluation, the user must also look into AuditLog.authentication_info.resource_attributes. Defaults to nil."},{"ref":"GoogleApi.ServiceControl.V1.Model.RequestMetadata.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.RequestMetadata.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.RequestMetadata.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.RequestMetadata.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.Resource.html","title":"GoogleApi.ServiceControl.V1.Model.Resource","type":"module","doc":"This message defines core attributes for a resource. A resource is an addressable (named) entity provided by the destination service. For example, a file stored on a network storage service. Attributes labels (map()): The labels or tags on the resource, such as AWS resource tags and Kubernetes resource labels. Defaults to nil. name (String.t): The stable identifier (name) of a resource on the service. A resource can be logically identified as &quot;//{resource.service}/{resource.name}&quot;. The differences between a resource name and a URI are: Resource name is a logical identifier, independent of network protocol and API version. For example, //pubsub.googleapis.com/projects/123/topics/news-feed. URI often includes protocol and version information, so it can be used directly by applications. For example, https://pubsub.googleapis.com/v1/projects/123/topics/news-feed. See https://cloud.google.com/apis/design/resource_names for details. Defaults to nil. service (String.t): The name of the service that this resource belongs to, such as pubsub.googleapis.com. The service may be different from the DNS hostname that actually serves the request. Defaults to nil. type (String.t): The type of the resource. The scheme is platform-specific because different platforms define their resources differently. Defaults to nil."},{"ref":"GoogleApi.ServiceControl.V1.Model.Resource.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.Resource.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.Resource.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.Resource.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.ResourceInfo.html","title":"GoogleApi.ServiceControl.V1.Model.ResourceInfo","type":"module","doc":"Describes a resource associated with this operation. Attributes resourceContainer (String.t): The identifier of the parent of this resource instance. Must be in one of the following formats: “projects/” “folders/” “organizations/” Defaults to nil. resourceLocation (String.t): The location of the resource. If not empty, the resource will be checked against location policy. The value must be a valid zone, region or multiregion. For example: &quot;europe-west4&quot; or &quot;northamerica-northeast1-a&quot; Defaults to nil. resourceName (String.t): Name of the resource. This is used for auditing purposes. Defaults to nil."},{"ref":"GoogleApi.ServiceControl.V1.Model.ResourceInfo.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.ResourceInfo.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.ResourceInfo.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.ResourceInfo.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.ResourceLocation.html","title":"GoogleApi.ServiceControl.V1.Model.ResourceLocation","type":"module","doc":"Location information about a resource. Attributes currentLocations (list(String.t)): The locations of a resource after the execution of the operation. Requests to create or delete a location based resource must populate the &#39;current_locations&#39; field and not the &#39;original_locations&#39; field. For example: &quot;europe-west1-a&quot; &quot;us-east1&quot; &quot;nam3&quot; Defaults to nil. originalLocations (list(String.t)): The locations of a resource prior to the execution of the operation. Requests that mutate the resource&#39;s location must populate both the &#39;original_locations&#39; as well as the &#39;current_locations&#39; fields. For example: &quot;europe-west1-a&quot; &quot;us-east1&quot; &quot;nam3&quot; Defaults to nil."},{"ref":"GoogleApi.ServiceControl.V1.Model.ResourceLocation.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.ResourceLocation.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.ResourceLocation.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.ResourceLocation.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.ServiceAccountDelegationInfo.html","title":"GoogleApi.ServiceControl.V1.Model.ServiceAccountDelegationInfo","type":"module","doc":"Identity delegation history of an authenticated service account. Attributes firstPartyPrincipal (GoogleApi.ServiceControl.V1.Model.FirstPartyPrincipal.t): First party (Google) identity as the real authority. Defaults to nil. thirdPartyPrincipal (GoogleApi.ServiceControl.V1.Model.ThirdPartyPrincipal.t): Third party identity as the real authority. Defaults to nil."},{"ref":"GoogleApi.ServiceControl.V1.Model.ServiceAccountDelegationInfo.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.ServiceAccountDelegationInfo.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.ServiceAccountDelegationInfo.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.ServiceAccountDelegationInfo.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.Status.html","title":"GoogleApi.ServiceControl.V1.Model.Status","type":"module","doc":"The Status type defines a logical error model that is suitable for different programming environments, including REST APIs and RPC APIs. It is used by gRPC. Each Status message contains three pieces of data: error code, error message, and error details. You can find out more about this error model and how to work with it in the API Design Guide. Attributes code (integer()): The status code, which should be an enum value of google.rpc.Code. Defaults to nil. details (list(map())): A list of messages that carry the error details. There is a common set of message types for APIs to use. Defaults to nil. message (String.t): A developer-facing error message, which should be in English. Any user-facing error message should be localized and sent in the google.rpc.Status.details field, or localized by the client. Defaults to nil."},{"ref":"GoogleApi.ServiceControl.V1.Model.Status.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.Status.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.Status.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.Status.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.ThirdPartyPrincipal.html","title":"GoogleApi.ServiceControl.V1.Model.ThirdPartyPrincipal","type":"module","doc":"Third party identity principal. Attributes thirdPartyClaims (map()): Metadata about third party identity. Defaults to nil."},{"ref":"GoogleApi.ServiceControl.V1.Model.ThirdPartyPrincipal.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.ThirdPartyPrincipal.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.ThirdPartyPrincipal.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.ThirdPartyPrincipal.t/0","type":"type","doc":""}]